package no.ntnu.idatt1002.demo.data.Budget;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class FileHandlingBudgetArchive {
  private static final String filePath = "src/main/resources/budgets/";
  private static final String fileType = ".archive";

  public static void writeBudgetRegisterToArchive(BudgetRegister budgetNames) throws IOException {
    try (BufferedWriter bw = new BufferedWriter(new FileWriter(filePath + "Archive" + fileType))) {
      System.out.println(filePath + "Archive.txt");
      bw.write(budgetNames.toString());
    } catch (IOException ioe) {
      ioe.printStackTrace();
      throw new IOException("Could not write to file: Archive.txt", ioe);
    }
  }

  public static boolean isBudgetRegisterEmpty() throws IOException {
    try (BufferedReader br = new BufferedReader(new FileReader(filePath
        + "Archive" + fileType))) {
      return br.readLine() == null;
    }
  }
  public static BudgetRegister readBudgetArchive(String fileTitle) throws IOException {
    BudgetRegister budgetRegister = null;
    String budgetName;
    String line;

    try (BufferedReader br = new BufferedReader(
        new FileReader(filePath + "Archive" + fileType))) {

      String nextLine = br.readLine();
      while ((line = nextLine) != null) {
        System.out.println(line);
        nextLine = br.readLine();
        budgetName = line;

        if (budgetRegister == null) {
          budgetRegister = new BudgetRegister();
        }
        budgetRegister.addBudgetName(budgetName);
      }
    }
    return budgetRegister;
  }

  public static void writeSavingsToFile() {

  }

  public static boolean deleteBudgetDirectory(String budgetID) {
    File targetDirectory = new File(filePath + budgetID);
    System.out.println("Deleting directory:" + targetDirectory.getPath());

    String[]entries = targetDirectory.list();
    assert entries != null;
    for(String file : entries){
      File currentFile = new File(targetDirectory.getPath(),file);
      System.out.println("Deleting file:" + currentFile.delete());
    }

    return targetDirectory.delete();
  }
}
